
import gui.ClosableJFrame;

import java.io.Serializable;
import java.awt.image.BufferedImage;
import java.awt.*;

import j2d.ImageUtils;


/**
 * Created by IntelliJ IDEA.
 * User: John
 * Date: Sep 26, 2005
 * Time: 11:10:27 PM
 * To change this template use File | Settings | File Templates.
 */

final public class Assign04_JJL implements Serializable {
/*
Due : Oct 10, 2005:

Write a program that inputs a java.awt.Image and, using the PMF computed from
HW3, perform a UNAHE on the image.  How will [you] implement a LUT on a 24 bit
image?  For each input color, there must be an output color.  That is:
       ColorOUt = lut(ColorIn);
This type of look up will have to be performed on a pixel-by-pixel basis

What kind of data structure will you use? Recall that there can be up
to 16 million colors on input and these must be mapped to some output.

*/

    public static void displayOutput(BufferedImage bi, String s) {
        ClosableJFrame outFrame = new ClosableJFrame(s);
        Container c1 = outFrame.getContentPane();
        ImageUtils.ImagePanel ip = new ImageUtils.ImagePanel(bi);
        c1.add(ip); // add imagepanel
        outFrame.pack();
        outFrame.setVisible(true);
    }

    public static void displayOutput(Image image, String s) {
        ClosableJFrame outFrame = new ClosableJFrame(s);
        Container c1 = outFrame.getContentPane();
        ImageUtils.ImagePanel ip = new ImageUtils.ImagePanel(image);
        c1.add(ip); // add imagepanel
        outFrame.pack();
        outFrame.setVisible(true);
    }

    public static void displayHistogramsRGB(int[][] inPix,String sIn){

        int[] rgbMask = { 0x00FF0000,0x0000FF00, 0x000000FF};
        int[] rgbShift = { 16, 8, 0};
        String[] rgbString = {"Red ",
                        "Green ",
                         "Blue "};

        int len = inPix.length;
        int wid = inPix[0].length;

        for (int rgbs=0; rgbs<3;rgbs++){   // for each color
            int[] hist = new int[256];
            for (int i = 0; i < len; i++) {
               for (int j = 0; j < wid; j++) {
                 int x = (inPix[i][j]& rgbMask[rgbs]) >> rgbShift[rgbs];
                 hist[x]= hist[x]+1;
               }
            }
            // find max of hist to scale it
            int max = 0;
            for (int i = 0; i < hist.length; i++) {
                if(max < hist[i]) max = hist[i];
            }
            // build the histogram image
            BufferedImage histOut = new BufferedImage(256,256, BufferedImage.TYPE_INT_RGB);

            int[][] histImage = new int[256][256];  // build the histogram display
            int[] colorCode = {0x00FF8080,0x0080FF80, 0x008080FF};
            int[] bgColor =  {0x00FFFFFF,0x00FFFFFF,0x00FFFFFF};
            int nset;
            System.out.println("rgbs= "+rgbs+" max hist="+max);
            for(int i=0;i<255 ; i++){
                // loop through all hist
                nset = (int) (255.*(double)hist[i]/(double)max);
                if (nset>0){
                  for(int k=0; k <nset; k++){
                    histOut.setRGB(i,255-k, colorCode[rgbs]);
                  }
                }
                if(nset<255){
                  for(int k = nset; k<256;k++){
                     histOut.setRGB(i,255-k, bgColor[rgbs]);
                  }
                }
            }
            // display histImage
           displayOutput(histOut, sIn+rgbString[rgbs]+" Max= "+max );

        }
    }

    private void processImage() {

        BufferedImage biIn;
        biIn = j2d.ImageUtils.getBufferedImage2(j2d.ImageUtils.getImage());

        displayOutput(biIn, "Input Image");

        biIn = j2d.ImageUtils.getBufferedImage2(biIn);
        int [][] plane = new int[biIn.getWidth()][biIn.getHeight()];
        int w = plane.length;
        int h = plane[0].length;
        for (int i = 0; i < w; i++) {
            for (int j = 0; j < h; j++) {
                plane[i][j] = biIn.getRGB(i, j);
            }
        }
       // assign04_JJL.MyStatsA4 ms = new assign04_JJL.MyStatsA4();
        int [][] planeOut = new int[w][h];
        planeOut = performUNAHE(plane);

        BufferedImage biOut = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);
        /* comvert each pixel of plane[][] to biOut */
        for (int i = 0; i < w; i++) {
            for (int j = 0; j < h; j++) {
                biOut.setRGB(i, j, planeOut[i][j]);
            }
        }
        displayHistogramsRGB(plane,"Input:");
        displayOutput(biOut, "Output Image");
        displayHistogramsRGB(planeOut,"Output:");
      
    }
    public int[][] performUNAHE(int plane[][]) {   /* operate on 24 bit data */
        int width = plane.length;
        int height = plane[0].length;
        int total = width * height;    /* total number of pixels */

        int[][] unahe = new int[width][height];
        Unahe u = new Unahe();
       //todo
        u.makeUnahe(plane,width,height);
        for (int i = 0; i < width; i++) {
            for (int j = 0; j < height; j++) {
                int rgb = plane[i][j] & 0x00FFFFFF;
                unahe[i][j] = u.getUnahePix(rgb);  /* perfom look up table */
            }
        }
        return unahe;
    }
    public static void main
            (String[] args) {
            Assign04_JJL thisClass = new Assign04_JJL();
        thisClass.processImage();

    }
    private class Unahe {
        private int [] rFreq = new int[256];
        private int [] gFreq = new int[256];
        private int [] bFreq = new int[256];
        private int [] rLUT  = new int[256];
        private int [] gLUT = new int[256];
        private int [] bLUT = new int[256];
        public Unahe(){
            for (int i = 0; i < rFreq.length; i++) {
                rFreq[i] = 0;
                gFreq[i]= 0;
                bFreq[i]=0;
            }
        }
        public void makeUnahe(int[][] plane,int width,int height){
            for (int i = 0; i < width; i++) {
               for (int j = 0; j < height; j++) {
                   int c = plane[i][j] &0x00FFFFFF;
                   int r = (c&0xFF0000)>>16;
                   int g = (c&0xFF00)>>8;
                   int b = c&0xFF;

                   rFreq[r] = rFreq[r] +1;
                   gFreq[g] = gFreq[g] +1;
                   bFreq[b] = bFreq[b]+1;
               }
            }

                double total = (double)(height*width);
                double [] rCMF = new double[256];
                double [] bCMF = new double[256];
                double [] gCMF = new double[256];

                double xr = 0.0;
                double xg = 0.0;
                double xb = 0.0;
                double x = 0;
                for (int j = 0; j < 256; j++) {
                    /* convert frequencies to Cummulative Mass Function */
                    x =(double)rFreq[j]/total;
                    xr = xr+x;  // CMF
                    rCMF[j] = xr;
                    x = (double)gFreq[j]/total;
                    xg = xg+x;
                    gCMF[j] = xg;
                    x = (double)bFreq[j]/total;
                    xb = xb+x;
                    bCMF[j] =xb;
                    rLUT[j] = (int)(rCMF[j]*255.);
                    gLUT[j] = (int)(gCMF[j]*255.);
                    bLUT[j] = (int)(bCMF[j]*255.);
                }

        }
        public int getUnahePix(int rgb) {
              int c = rgb & 0x00FFFFFF;
              int r = c>>16;
              r = rLUT[r];
              int g = (c&0xFF00)>>8;
              g = gLUT[g];
              int b = c&0xFF;
              b = bLUT[b];
            return ( (r<<16)|(g << 8) | b);
        }
    }
}
